/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: NamingEnumerationImpl.java 5:07:43 PM ddesjardins $
 * -------------------------------------------------------------------------
 */
package org.ow2.petals.communication.jndi.client.naming;

import java.util.Arrays;
import java.util.Iterator;

import javax.naming.NamingEnumeration;
import javax.naming.NamingException;

/**
 * NamingEnumeration implementation
 *
 * @author ddesjardins - eBMWebsourcing
 */
public class NamingEnumerationImpl<T> implements NamingEnumeration<T> {

    /**
     * Iterator
     */
    protected Iterator<T> iterator;

    /**
     * Creates a new instance of {@link NamingEnumerationImpl}
     *
     * @param array
     */
    public NamingEnumerationImpl(T[] array) {
        super();
        iterator = Arrays.asList(array).iterator();
    }

    /*
     * (non-Javadoc)
     * @see javax.naming.NamingEnumeration#close()
     */
    public void close() throws NamingException {
        iterator = null;
    }

    /*
     * (non-Javadoc)
     * @see javax.naming.NamingEnumeration#hasMore()
     */
    public boolean hasMore() throws NamingException {
        return iterator.hasNext();
    }

    /*
     * (non-Javadoc)
     * @see java.util.Enumeration#hasMoreElements()
     */
    public boolean hasMoreElements() {
        return iterator.hasNext();
    }

    /*
     * (non-Javadoc)
     * @see javax.naming.NamingEnumeration#next()
     */
    public T next() throws NamingException {
        return iterator.next();
    }

    /*
     * (non-Javadoc)
     * @see java.util.Enumeration#nextElement()
     */
    public T nextElement() {
        return iterator.next();
    }

}
