/**
 * PETALS: PETALS Services Platform Copyright (C) 2009 EBM WebSourcing
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
 * 
 * Initial developer(s): EBM WebSourcing
 */
package org.ow2.petals.jbi.component.context;

import javax.jbi.JBIException;
import javax.jbi.component.Component;
import javax.jbi.messaging.MessagingException;

import org.ow2.petals.jbi.messaging.endpoint.ServiceEndpoint;
import org.ow2.petals.jbi.messaging.exchange.DeliveryChannel;
import org.ow2.petals.jbi.messaging.routing.RouterService;
import org.ow2.petals.jbi.security.SecurityContext;

/**
 * The PEtALS component context interface.
 * 
 * @author chamerling - eBM WebSourcing
 * 
 */
public interface ComponentContext extends javax.jbi.component.ComponentContext {

    SecurityContext getSecurityContext();

    void setSecurityContext(SecurityContext securityContext);

    void deregisterAllEndpoints() throws JBIException;

    RouterService getRouter();

    ServiceEndpoint getAddress();

    Component getComponent();

    void setComponent(Component component);

    void clear();

    org.objectweb.util.monolog.api.Logger getLogger();

    DeliveryChannel getDeliveryChannel() throws MessagingException;

}
