package org.ow2.petals.jbi.messaging.registry;

import javax.xml.namespace.QName;

public class EndpointAlreadyExistsException extends RegistryException {
    
    private static final long serialVersionUID = 1L;

    /**
     * Name of the already existing endpoint.
     */
    final private String existingEndpointName;

    /**
     * Servcie of the already existing endpoint.
     */
    final private QName existingEndpointService;

    public EndpointAlreadyExistsException(final String existingEndpointName,
            final QName existingEndpointService) {
        super("The endpoint '" + existingEndpointName + "' for service '"
                + existingEndpointService.toString() + "' already exists.");
        this.existingEndpointName = existingEndpointName;
        this.existingEndpointService = existingEndpointService;
    }

    public String getExistingEndpointName() {
        return this.existingEndpointName;
    }

    public QName getExistingEndpointService() {
        return this.existingEndpointService;
    }

}
