package org.ow2.petals.system.repository.exception;

import org.ow2.petals.system.repository.RepositoryServiceImpl.EntityType;

public class EntityAlreadyExistsException extends RepositoryException {

    /**
     * 
     */
    private static final long serialVersionUID = -5791080473814665338L;

    private final String entityName;

    private final EntityType entityType;

    public EntityAlreadyExistsException(final String entityName, final EntityType entityType) {
        super();
        this.entityName = entityName;
        this.entityType = entityType;
    }

    @Override
    public String getMessage() {
        return "Entity '" + this.entityName + "' (" + this.entityType.toString()
                + ") already exists in the repository.";
    }

}
