package org.ow2.petals.system.repository.exception;


public class SharedLibraryAlreadyExistsException extends RepositoryException {

    /**
     * 
     */
    private static final long serialVersionUID = -3099591108825394181L;

    private final String slName;
    private final String version;

    public SharedLibraryAlreadyExistsException(final String slName, final String version,
            final Throwable e) {
        super("Shared library '" + slName + ", " + version
                + "' already registered in the repository.", e);
        this.slName = slName;
        this.version = version;
    }

    public String getSharedLibraryName() {
        return this.slName;
    }

    public String getVersion() {
        return this.version;
    }

}
