package org.ow2.petals.system.systemstate.exception;

import org.ow2.petals.systemstate.SystemStateException;

public class SharedLibraryAlreadyExistsException extends SystemStateException {

    /**
     * 
     */
    private static final long serialVersionUID = -1980658587424589386L;

    private final String slName;
    private final String version;

    public SharedLibraryAlreadyExistsException(final String slName, final String version) {
        super("Shared library '" + slName + ", " + version + "' already registered in the system state.");
        this.slName = slName;
        this.version = version;
    }

    public String getSharedLibraryName() {
        return this.slName;
    }

    public String getVersion() {
        return this.version;
    }

}
